#include <Windows.h>
#include <winioctl.h>
#include <NtDDNdis.h>
#include <nuiouser.h>
#include "Common.h"
#include <eapol.h>
#include <wzcsapi.h>
#include <stdio.h>

#if _MSC_VER > 1000
#pragma once
#endif

struct BSSIDInfo
{
	BYTE BSSID[6];	//mac
	WCHAR SSID[32];
	int RSSI;
	int Channel;
	int Infastructure;
	int Auth;
};

class CWifi
{
public:
	CWifi();
	~CWifi();

	BOOL IsWiFiPresent();
	BOOL GetAdapters(LPWSTR pDest, DWORD &dwBufSizeBytes);
	BOOL RefreshBSSIDs(LPWSTR pAdapter);
	BOOL GetBSSIDs(LPWSTR pAdapter, struct BSSIDInfo *pDest, DWORD &dwBufSizeBytes, DWORD &dwReturnedItems);	
	BOOL SetAdHocConnection(LPWSTR pAdapter, LPSTR pSsid);
	BOOL SetConnectionMode(LPWSTR pAdapter, NDIS_802_11_NETWORK_INFRASTRUCTURE iMode, NDIS_802_11_AUTHENTICATION_MODE aMode);
	BOOL SetSsid(LPWSTR pAdapter, LPCSTR pSsid);
	BOOL GetBSSID(LPWSTR pAdapter, LPWSTR pSsid, struct BSSIDInfo *pDest);
	BOOL SetEncryptionKey(LPWSTR pAdapter, BYTE* pKey, UINT uKeyLen);
	BOOL WZCCheckAssociation(LPWSTR pAdapterName);
	BOOL WZCConfigureNetwork(LPWSTR pAdapter, struct BSSIDInfo *pBssid, BYTE* pKey, UINT uKeyLen);
	BOOL WZCConnectToPreferred(LPWSTR pAdapterName); // Nome senza GUID
	BOOL WZCConnectToOpen(LPWSTR pAdapterName); // Nome sezna GUID
	BOOL Disassociate(LPWSTR pAdapter);

private:
	BOOL OpenDriver();
	void CloseDriver();

	CRITICAL_SECTION m_Lock;
	HANDLE m_hNDUIO;
};

